# Record Class ARI1InstrumentDescription

java.lang.Object
java.lang.Record
com.io7m.aradine.instrument.spi1.ARI1InstrumentDescription

Record Components:
  `group` - The group of the instrument
  `identifier` - The unique identifier of the instrument
  `version` - The version of the instrument
  `metadata` - The metadata strings declared in the instrument description
  `parameters` - The parameters declared by the instrument
  `ports` - The ports declared by the instrument

public record ARI1InstrumentDescription(ARI1DottedName group, ARI1DottedName identifier, ARI1Version version, Map<String,String> metadata, Map<ARI1ParameterNumber, ARI1ParameterDescriptionType> parameters, Map<ARI1PortNumber, ARI1PortDescription> ports) extends Record
Create an instrument description.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ARI1InstrumentDescription(ARI1DottedName group, ARI1DottedName identifier, ARI1Version version, Map<String,String> metadata, Map<ARI1ParameterNumber, ARI1ParameterDescriptionType> parameters, Map<ARI1PortNumber, ARI1PortDescription> ports)`
  Create an instrument description.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `ARI1DottedName`
  `group()`
  Returns the value of the `group` record component.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `ARI1DottedName`
  `identifier()`
  Returns the value of the `identifier` record component.
  `Map<String,String>`
  `metadata()`
  Returns the value of the `metadata` record component.
  `Map<ARI1ParameterNumber, ARI1ParameterDescriptionType>`
  `parameters()`
  Returns the value of the `parameters` record component.
  `Map<ARI1PortNumber, ARI1PortDescription>`
  `ports()`
  Returns the value of the `ports` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.
  `ARI1Version`
  `version()`
  Returns the value of the `version` record component.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### ARI1InstrumentDescription

    public ARI1InstrumentDescription(ARI1DottedName group, ARI1DottedName identifier, ARI1Version version, Map<String,String> metadata, Map<ARI1ParameterNumber, ARI1ParameterDescriptionType> parameters, Map<ARI1PortNumber, ARI1PortDescription> ports)
    Create an instrument description.
    Parameters:
      `group` - The group of the instrument
      `identifier` - The unique identifier of the instrument
      `version` - The version of the instrument
      `metadata` - The metadata strings declared in the instrument description
      `parameters` - The parameters declared by the instrument
      `ports` - The ports declared by the instrument

- ## Method Details

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### group

    public ARI1DottedName group()
    Returns the value of the `group` record component.
    Returns:
      the value of the `group` record component

  - ### identifier

    public ARI1DottedName identifier()
    Returns the value of the `identifier` record component.
    Returns:
      the value of the `identifier` record component

  - ### version

    public ARI1Version version()
    Returns the value of the `version` record component.
    Returns:
      the value of the `version` record component

  - ### metadata

    public Map<String,String> metadata()
    Returns the value of the `metadata` record component.
    Returns:
      the value of the `metadata` record component

  - ### parameters

    public Map<ARI1ParameterNumber, ARI1ParameterDescriptionType> parameters()
    Returns the value of the `parameters` record component.
    Returns:
      the value of the `parameters` record component

  - ### ports

    public Map<ARI1PortNumber, ARI1PortDescription> ports()
    Returns the value of the `ports` record component.
    Returns:
      the value of the `ports` record component